osgParticle::MultiSegmentPlacer Class Reference

`#include <MultiSegmentPlacer>`

Inheritance diagram for osgParticle::MultiSegmentPlacer:

## Public Member Functions

| MultiSegmentPlacer ()
| MultiSegmentPlacer (const MultiSegmentPlacer &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgParticle, MultiSegmentPlacer)
int | numVertices () const
| Get the number of vertices which define the segments.
const osg::Vec3 & | getVertex (int i) const
| Get a vertex.
void | setVertex (int i, const osg::Vec3 &v)
| Set a vertex.
void | setVertex (int i, float x, float y, float z)
| Set a vertex.
void | addVertex (const osg::Vec3 &v)
| Add a vertex.
void | addVertex (float x, float y, float z)
| Add a vertex.
void | removeVertex (int i)
| Remove a vertex.
void | place (Particle *P) const
| Place a partice. Called automatically by `ModularEmitter`, do not call this method manually.
float | volume () const
| return the length of the multi-segment
osg::Vec3 | getControlPosition () const
| return the control position
Public Member Functions inherited from osgParticle::Placer
| Placer ()
| Placer (const Placer &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~MultiSegmentPlacer ()
MultiSegmentPlacer & | operator= (const MultiSegmentPlacer &)
Protected Member Functions inherited from osgParticle::Placer
| ~Placer ()
Placer & | operator= (const Placer &)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

A polyline-shaped particle placer. This placer class sets the position of incoming particles by choosing a random point on the specified sequence of connected segments.

## Constructor & Destructor Documentation

## MultiSegmentPlacer() [1/2]

osgParticle::MultiSegmentPlacer::MultiSegmentPlacer | ( |  | ) |

Referenced by META_Object(), MultiSegmentPlacer(), and operator=().

## MultiSegmentPlacer() [2/2]

osgParticle::MultiSegmentPlacer::MultiSegmentPlacer | ( | const MultiSegmentPlacer & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References MultiSegmentPlacer(), and osg::CopyOp::SHALLOW_COPY.

## ~MultiSegmentPlacer()

virtual osgParticle::MultiSegmentPlacer::~MultiSegmentPlacer | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addVertex() [1/2]

void osgParticle::MultiSegmentPlacer::addVertex | ( | const osg::Vec3 & | v | ) |

inline

Add a vertex.

Referenced by addVertex(), and META_Object().

## addVertex() [2/2]

void osgParticle::MultiSegmentPlacer::addVertex | ( | float | x,
|  | float | y,
|  | float | z )

inline

Add a vertex.

References addVertex().

## getControlPosition()

osg::Vec3 osgParticle::MultiSegmentPlacer::getControlPosition | ( |  | ) | const

inline virtual

return the control position

Implements osgParticle::Placer.

Referenced by place().

## getVertex()

const osg::Vec3 & osgParticle::MultiSegmentPlacer::getVertex | ( | int | i | ) | const

inline

Get a vertex.

Referenced by META_Object().

## META_Object()

osgParticle::MultiSegmentPlacer::META_Object | ( | osgParticle | ,
|  | MultiSegmentPlacer | )

References addVertex(), getVertex(), MultiSegmentPlacer(), numVertices(), removeVertex(), and setVertex().

## numVertices()

int osgParticle::MultiSegmentPlacer::numVertices | ( |  | ) | const

inline

Get the number of vertices which define the segments.

Referenced by META_Object().

## operator=()

MultiSegmentPlacer & osgParticle::MultiSegmentPlacer::operator= | ( | const MultiSegmentPlacer & |  | ) |

inline protected

References MultiSegmentPlacer().

## place()

void osgParticle::MultiSegmentPlacer::place | ( | Particle * | P | ) | const

virtual

Place a partice. Called automatically by `ModularEmitter`, do not call this method manually.

Implements osgParticle::Placer.

References getControlPosition(), and volume().

## removeVertex()

void osgParticle::MultiSegmentPlacer::removeVertex | ( | int | i | ) |

inline

Remove a vertex.

Referenced by META_Object().

## setVertex() [1/2]

void osgParticle::MultiSegmentPlacer::setVertex | ( | int | i,
|  | const osg::Vec3 & | v )

inline

Set a vertex.

Referenced by META_Object().

## setVertex() [2/2]

void osgParticle::MultiSegmentPlacer::setVertex | ( | int | i,
|  | float | x,
|  | float | y,
|  | float | z )

inline

Set a vertex.

## volume()

float osgParticle::MultiSegmentPlacer::volume | ( |  | ) | const

inline virtual

return the length of the multi-segment

Reimplemented from osgParticle::Placer.

Referenced by place().

The documentation for this class was generated from the following file:

- MultiSegmentPlacer